Summary:	letsencrypt/acme client implemented as a shell-script
Name:		dehydrated
Version:	0.3.1
Release:	2
License:	MIT
Group:		Applications/Networking
Source0:	https://github.com/lukas2511/dehydrated/archive/v%{version}/%{name}-%{version}.tar.gz
# Source0-md5:	7a3b92b963da6469c4a53f051d6efa24
Source1:	apache.conf
Source2:	lighttpd.conf
Source3:	nginx.conf
Source4:	domains.txt
Source5:	hook.sh
Source6:	crontab
Patch0:		pld.patch
URL:		https://github.com/lukas2511/dehydrated
BuildRequires:	rpmbuild(macros) >= 1.713
Requires:	ca-certificates
Requires:	crondaemon
Requires:	curl
Requires:	diffutils
Requires:	grep
Requires:	mktemp
Requires:	openssl-tools
Requires:	sed
Requires:	webapps
Suggests:	webserver(access)
Suggests:	webserver(alias)
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_webapps	/etc/webapps
%define		_webapp		%{name}
%define		_sysconfdir	%{_webapps}/%{_webapp}
%define		_appdir		%{_datadir}/%{_webapp}

%description
This is a client for signing certificates with an ACME-server
(currently only provided by letsencrypt) implemented as a relatively
simple bash-script.

Current features:
- Signing of a list of domains
- Signing of a CSR
- Renewal if a certificate is about to expire or SAN (subdomains)
  changed
- Certificate revocation

%prep
%setup -q
%patch0 -p1

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_sbindir},%{_sysconfdir}/certs,/etc/cron.d} \
	$RPM_BUILD_ROOT/var/lib/%{name}/{accounts,acme-challenge,certs}

install -p %{name} $RPM_BUILD_ROOT%{_sbindir}
cp -p %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}/apache.conf
cp -p %{SOURCE2} $RPM_BUILD_ROOT%{_sysconfdir}/lighttpd.conf
cp -p %{SOURCE3} $RPM_BUILD_ROOT%{_sysconfdir}/nginx.conf
cp -p docs/examples/config $RPM_BUILD_ROOT%{_sysconfdir}
cp -p %{SOURCE4} $RPM_BUILD_ROOT%{_sysconfdir}
cp -p %{SOURCE6} $RPM_BUILD_ROOT/etc/cron.d/%{name}
install -p %{SOURCE5} $RPM_BUILD_ROOT%{_sysconfdir}
cp -p $RPM_BUILD_ROOT%{_sysconfdir}/{apache,httpd}.conf

%clean
rm -rf $RPM_BUILD_ROOT

%triggerin -- apache1 < 1.3.37-3, apache1-base
%webapp_register apache %{_webapp}

%triggerun -- apache1 < 1.3.37-3, apache1-base
%webapp_unregister apache %{_webapp}

%triggerin -- apache < 2.2.0, apache-base
%webapp_register httpd %{_webapp}

%triggerun -- apache < 2.2.0, apache-base
%webapp_unregister httpd %{_webapp}

%triggerin -- lighttpd
%webapp_register lighttpd %{_webapp}

%triggerun -- lighttpd
%webapp_unregister lighttpd %{_webapp}

%triggerin -- nginx
%webapp_register nginx %{_webapp}

%triggerun -- nginx
%webapp_unregister nginx %{_webapp}

%files
%defattr(644,root,root,755)
%doc README.md CHANGELOG LICENSE
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/cron.d/%{name}
%dir %attr(750,root,http) %{_sysconfdir}
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/apache.conf
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/httpd.conf
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/lighttpd.conf
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/nginx.conf
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/config
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/domains.txt
%attr(750,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/hook.sh
%attr(755,root,root) %{_sbindir}/%{name}
%dir %attr(751,root,root) /var/lib/%{name}
%dir %attr(700,root,root) /var/lib/%{name}/accounts
%dir %attr(700,root,root) /var/lib/%{name}/certs
# challenges written here, need to be readable by webserver
%dir %attr(751,root,root) /var/lib/%{name}/acme-challenge
%changelog
* Mon Jan 02 2017 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/dehydrated.git;a=log;h=master

* Mon Jan 02 2017 Elan Ruusamäe <glen@delfi.ee> f85acc7
- release 2 (by relup.sh)

* Mon Jan 02 2017 Elan Ruusamäe <glen@delfi.ee> 69865db
- hook: detect haproxy

* Mon Jan 02 2017 Elan Ruusamäe <glen@delfi.ee> 90738cc
- requires ca-certificates

* Mon Jan 02 2017 Elan Ruusamäe <glen@delfi.ee> b9ec422
- requires diff

* Tue Dec 06 2016 Elan Ruusamäe <glen@delfi.ee> ffc43e1
- do not obsolete letsencrypt.sh

* Tue Dec 06 2016 Elan Ruusamäe <glen@delfi.ee> de4255b
- works for me; rel 1

* Tue Nov 22 2016 Elan Ruusamäe <glen@delfi.ee> 657cacc
- scan /etc/webapps/dehydrated for config

* Tue Nov 22 2016 Elan Ruusamäe <glen@delfi.ee> aebe760
- add nginx config and webapp config

* Tue Nov 22 2016 Elan Ruusamäe <glen@delfi.ee> e354c9b
- add certs dir, also in /var

* Tue Nov 22 2016 Elan Ruusamäe <glen@delfi.ee> f19ccd9
- move acme-challenge and accounts to /var/lib

* Tue Nov 22 2016 Elan Ruusamäe <glen@delfi.ee> 00916b4
- nginx package and binary names were sanitized

* Mon Oct 17 2016 Elan Ruusamäe <glen@delfi.ee> 3ec257e
- use upstream config (from examples)

* Mon Oct 17 2016 Elan Ruusamäe <glen@delfi.ee> 7693646
- config is without .sh ext

* Mon Oct 17 2016 Elan Ruusamäe <glen@delfi.ee> 4c3f6e0
- update config dir to be dehydrated

* Mon Oct 17 2016 Elan Ruusamäe <glen@delfi.ee> 2e50938
- challenges dir set to /var/lib/dehydrated

* Mon Oct 17 2016 Elan Ruusamäe <glen@delfi.ee> 0b9f695
- letsencrypt.sh renamed to dehydrated; up to 0.3.1

* Sun Aug 14 2016 Arkadiusz Miśkiewicz <arekm@maven.pl> f4d4983
- rel 4; update letsencrypt license url

* Sat Aug 13 2016 Arkadiusz Miśkiewicz <arekm@maven.pl> 355c28d
- keep copy of old cert in case if it wasn't letsencrypt one

* Sat Aug 13 2016 Arkadiusz Miśkiewicz <arekm@maven.pl> cd17a5e
- enable hook by default

* Thu Aug 04 2016 Elan Ruusamäe <glen@delfi.ee> 6e45b6d
- add nginx.conf

